/***************************************************************************
                          gra.cpp  -  description
                             -------------------
    begin                : Don Nov 20 23:54:54 CET 2003
    copyright            : (C) 2003 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Linux includes
#include <stdlib.h>

 
// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qpushbutton.h>
#include <qimage.h>
#include <qpixmap.h>



// include files for KDE
#include <kprinter.h>
#include <kdialog.h>
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <klocale.h>
#include <kconfig.h>
#include <kstdaction.h>
#include <ktextedit.h>
#include <kpushbutton.h>
#include <kstandarddirs.h>
#include <kmessagebox.h> 


// application specific includes
#include "kphysics.h"
#include "kphysicsview.h"
#include "kphysicsdoc.h"
//#include "mykugel.h"


#define ID_STATUS_MSG 1

GraApp::GraApp(QWidget* , const char* name):KMainWindow(0, name)
{
  config=kapp->config();

  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initStatusBar();
  initActions();
  initTimer();
  initDocument();
  initView();
	
  readOptions();

  ///////////////////////////////////////////////////////////////////
  // disable actions at startup
  //fileSave->setEnabled(false);
  //fileSaveAs->setEnabled(false);
  //filePrint->setEnabled(false);
  editCut->setEnabled(false);
  editCopy->setEnabled(false);
  editPaste->setEnabled(false);
  //////
  /*QFrame myframe=new QFrame(GraApp);
  myframe->setGeometry(50,50,400,400);  
  KPushButton b* = new KPushButton("Test",myframe);*/
  //  myTimer = new QTimer();


  gravitation=false;
  erdgravitation=false;//true;
  elec=true;//false;//false;
  reibung=false;//true;//false;
  editable=false;
  deleteable=false;
  newable=false;
  //false;
  testdebug=0;
  feldanz=0;
  
  
  actionTimerStart->setEnabled(true);
  actionTimerStop->setEnabled(false);
  actionGravitationAn->setEnabled(true);
  actionGravitationAus->setEnabled(false);


  myImage=new QImage(400,400,32,256);
    
}

GraApp::~GraApp()
{
  delete myImage;
  delete kugel;
}

void GraApp::initActions()
{
  fileNewWindow = new KAction(i18n("New &Window"), 0, 0, this, SLOT(slotFileNewWindow()), actionCollection(),"file_new_window");
  fileNew = KStdAction::openNew(this, SLOT(slotFileNew()), actionCollection());
  fileOpen = KStdAction::open(this, SLOT(slotFileOpen()), actionCollection());
  fileOpenRecent = KStdAction::openRecent(this, SLOT(slotFileOpenRecent(const KURL&)), actionCollection());
  fileSave = KStdAction::save(this, SLOT(slotFileSave()), actionCollection());
  fileSaveAs = KStdAction::saveAs(this, SLOT(slotFileSaveAs()), actionCollection());
  fileClose = KStdAction::close(this, SLOT(slotFileClose()), actionCollection());                                       
  filePrint = KStdAction::print(this, SLOT(slotFilePrint()), actionCollection());
  //locate("appdata", "pics/puddle.png")
                                                                       
//  actionTimerStart = new KAction(i18n("Start"), "/home/walter/kdeprogra/kugel/kphysics/pics/play.png", 0, this, SLOT(slotTimerStart()/*slovtFilePrint()*/), actionCollection(),"timer_start");
//  actionTimerStop = new KAction(i18n("Stop"), "/home/walter/kdeprogra/kugel/kphysics/pics/pause.png", 0, this, SLOT(slotTimerStop()/*slotFilePrint()*/), actionCollection(),"timer_stop");

//  actionGravitationAn = new KAction(i18n("Gravitation An"), "/home/walter/kdeprogra/kugel/kphysics/pics/gra_an.png", 0, this, SLOT(slotGravitationAn()/*slotFilePrint()*/), actionCollection(),"gravitation_an");
//  actionGravitationAus = new KAction(i18n("Gravitation Aus"), "/home/walter/kdeprogra/kugel/kphysics/pics/gra_aus.png", 0, this, SLOT(slotGravitationAus()/*slotFilePrint()*/), actionCollection(),"gravitation_aus");

  actionTimerStart = new KAction(i18n("Start"), locate("appdata", "pics/play.png"), 0, this, SLOT(slotTimerStart()/*slovtFilePrint()*/), actionCollection(),"timer_start");
  actionTimerStop = new KAction(i18n("Stop"), locate("appdata", "pics/pause.png"), 0, this, SLOT(slotTimerStop()/*slotFilePrint()*/), actionCollection(),"timer_stop");

  actionGravitationAn = new KAction(i18n("Gravitation An"), locate("appdata", "pics/gra_an.png"), 0, this, SLOT(slotGravitationAn()/*slotFilePrint()*/), actionCollection(),"gravitation_an");
  actionGravitationAus = new KAction(i18n("Gravitation Aus"), locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotGravitationAus()/*slotFilePrint()*/), actionCollection(),"gravitation_aus");
  actionShowLadungsFeld = new KAction(i18n("Elektrisches Feld anzeigen"), locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotShowLadungsFeld()/*slotFilePrint()*/), actionCollection(),"show_ladungen");
  actionShowGravFeld = new KAction(i18n("Gravitationsfeld anzeigen"), locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotShowGravFeld()/*slotFilePrint()*/), actionCollection(),"show_grav");
  
  
  //-----------------------
  testtogglea = new KToggleAction("Anzeigen,",locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotShowGravFeld()/*slotFilePrint()*/),actionCollection(),"a1"); 
  /*(const QString &text, const KShortcut &cut=KShortcut(), QObject *parent=0, const char *name=0)
  KAction(i18n("Gravitationsfeld anzeigen"), locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotShowGravFeld()/), actionCollection(),"show_grav");
  */
  toolBar("myToolBar")->insertSeparator();
  toolBar("myToolBar")->insertButton("Test",23);
  testmenua = new KActionMenu ("bla",actionCollection(),"a2"); 

  
  
  
  
 // KActionMenu* testmenua;
  editonoff = new KToggleAction("Editieren On/Off",locate("appdata", "pics/gra_edit.png")/*locate("appdata", "pics/gra_aus.png")*/, 0, this, SLOT(slotEditOnOff()/*slotFilePrint()*/),actionCollection(),"editonoff"); 
      
  
  editmenu = new KActionMenu ("Edtier Men",locate("appdata", "pics/gra_menu.png"),actionCollection(),"editmenu"); 
  editnew = new KAction(i18n("Neues Teilchen"), locate("appdata", "pics/gra_new.png"), 0, this, SLOT(slotEditNew()/*slotFilePrint()*/),actionCollection(),"editnew");
  editedit = new KAction(i18n("Teilchen bearbeiten"), locate("appdata", "pics/gra_edit.png"), 0, this, SLOT(slotEditEdit()/*slotFilePrint()*/),actionCollection(),"editedit");
  editdelete= new KAction(i18n("Teilchen loeschen"), locate("appdata", "pics/gra_delete.png"), 0, this, SLOT(slotEditDelete()/*slotFilePrint()*/),actionCollection(),"editdelete");
    
  editmenu->setEnabled(false);
  editmenu->insert(editedit);
  editmenu->insert(editnew);
  editmenu->insert(editdelete);
  
  QStringList strlist;
  strlist.append( "Masse" );
  //  fonts += "Courier";
  //  ;
  editMasse = new KListAction ("Masse editieren",locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotEditMasse()/*slotFilePrint()*/),actionCollection(),"editmasse"); //("bla",KShortcut(),actionCollection(),"a3"); 
  editMasse->setItems(strlist); 
  strlist.clear();
  
  strlist.append( "Ladung" );
  editLadung = new KListAction ("Ladung editieren",locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotEditLadung()/*slotFilePrint()*/),actionCollection(),"editladung"); //("bla",KShortcut(),actionCollection(),"a3"); 
  editLadung->setItems(strlist); 
  strlist.clear();
  
  strlist.append( "Radius" );  
  editRadius = new KListAction ("Radius editieren",locate("appdata", "pics/gra_aus.png"), 0, this, SLOT(slotEditRadius()/*slotFilePrint()*/),actionCollection(),"editradius"); //("bla",KShortcut(),actionCollection(),"a3"); 
  editRadius->setItems(strlist); 
  strlist.clear();
  
  editMasse->setEditable(true);
  editLadung->setEditable(true);
  editRadius->setEditable(true);
    
  
  fileQuit = KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection());
  editCut = KStdAction::cut(this, SLOT(slotEditCut()), actionCollection());
  editCopy = KStdAction::copy(this, SLOT(slotEditCopy()), actionCollection());
  editPaste = KStdAction::paste(this, SLOT(slotEditPaste()), actionCollection());
  viewActionToolBar = KStdAction::showToolbar(this, SLOT(slotViewActionToolBar()), actionCollection());
  viewToolBar = KStdAction::showToolbar(this, SLOT(slotViewToolBar()), actionCollection());
  
  viewStatusBar = KStdAction::showStatusbar(this, SLOT(slotViewStatusBar()), actionCollection());

  fileNewWindow->setStatusText(i18n("Opens a new application window"));
  fileNew->setStatusText(i18n("Creates a new Walter document"));
  fileOpen->setStatusText(i18n("Opens an existing document"));
  fileOpenRecent->setStatusText(i18n("Opens a recently used file"));
  fileSave->setStatusText(i18n("Saves the actual document"));
  fileSaveAs->setStatusText(i18n("Saves the actual document as..."));
  fileClose->setStatusText(i18n("Closes the actual document"));
  //filePrint ->setStatusText(i18n("Prints out the actual document"));
  fileQuit->setStatusText(i18n("Quits the application"));
  editCut->setStatusText(i18n("Cuts the selected section and puts it to the clipboard"));
  editCopy->setStatusText(i18n("Copies the selected section to the clipboard"));
  editPaste->setStatusText(i18n("Pastes the clipboard contents to actual position"));
  viewToolBar->setStatusText(i18n("Enables/disables the toolbar"));
  viewActionToolBar->setStatusText(i18n("Enables/disables the Action-toolbar"));
  viewStatusBar->setStatusText(i18n("Enables/disables the statusbar"));

  fileOpenRecent->setMaxItems(4);
  //fileOpenRecent->loadEntries (KConfig *config, QString groupname=QString::null)
  // use the absolute path to your graui.rc file for testing purpose in createGUI();
  //createGUI("/home/walter/kdeprogra/kugel/kphysics/kphysicsui.rc");
  createGUI();
  connect(this,SIGNAL(dockWindowPositionChanged(QDockWindow*)),this,SLOT(slotResize()));
  connect(this,SIGNAL(dockWindowPositionChanged(QDockWindow*)),this,SLOT(slotResize()));
  
  
  //KMessageBox::error(this,instance()->instanceName());
}


void GraApp::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  // STATUSBAR
  // TODO: add your own items you need for displaying current application status.
  statusBar()->insertItem(i18n("Ready."), ID_STATUS_MSG);
  //statusBar()->insertItem(i18n("Hh."), ID_STATUS_MSG);
}

void GraApp::initTimer()
{
  myTimer = new QTimer(this);
 //            QTimer *mt= new QTimer(&app);//QTimer::singleShot( 4*1000, &app, SLOT(quit()) );
                // create and show your widgets
            //return a.exec();
        //QTimer *timer = new QTimer( myObject );
  QObject::connect( myTimer, SIGNAL(timeout()), this, SLOT(slotTimer()/*timerDone()*/) );
        myTimer->start( 25, FALSE ); // 2 seconds single-shot timer
}


void GraApp::initDocument()
{
  srand((unsigned)(123123));
  doc = new GraDoc(this);
  //doc->newDocument();
  
  //test= new KPushButton("aasdbl",this);


}
void GraApp::initView2()
{ 


if(this->doc->kugelanz!=0) {//100;

 bool ia=myTimer->isActive();
 myTimer->stop();

 int i;
 for(i=0;i<=kugelanz-1;i++){
   delete kugel[i];
 } 
 //delete kugel[0];
  kugelanz=this->doc->kugelanz;//100;
  //KMessageBox::error(this,QString::number(kugelanz));
  delete [] kugel;
  //myCanvas->update();
  kugel=new MyKugel *[kugelanz];


//  int x1=0,y1=0,x2=115,y2=115;
  /*int x1=0,y1=0,x2=415,y2=415;

  myrechteck= new RechteckRaum(x1,y1,x2,y2);


  myLine = new QCanvasLine(myCanvas);
    myLine->setPoints(x1,y2,x2,y2);
    myLine->show();
  myLine2 = new QCanvasLine(myCanvas);
    myLine2->setPoints(x2,y1,x2,y2);
    myLine2->show();   */


  for(i=0;i<=kugelanz-1;i++){
    kugel[i] = new MyKugel(myCanvas);//QCanvasEllipse(myCanvas);
    kugel[i]->setX(this->doc->kugel[i]->x());
    kugel[i]->setY(this->doc->kugel[i]->y());
    kugel[i]->setZ(0);
    kugel[i]->setPen(QPen(black,3,SolidLine));//myPen);
    //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
    kugel[i]->setBrush(QBrush(QColor(this->doc->kugel[i]->brush().color().red(),
                                   this->doc->kugel[i]->brush().color().green(),
                                   this->doc->kugel[i]->brush().color().blue()),SolidPattern));

    kugel[i]->show();
    kugel[i]->setvel(this->doc->kugel[i]->getvel());
    kugel[i]->setwinkel(this->doc->kugel[i]->getwinkel());
    kugel[i]->setmasse(this->doc->kugel[i]->getmasse());
    kugel[i]->setradius(this->doc->kugel[i]->getradius());
    kugel[i]->setsolid(this->doc->kugel[i]->getsolid());  
    kugel[i]->setladung(this->doc->kugel[i]->getladung());  
    
  }  


   myCanvas->update();
   if (ia) {myTimer->start( 25, FALSE );}
}







}

void GraApp::initView()
{
  myTimer->stop();
  ////////////////////////////////////////////////////////////////////
  // create the main widget here that is managed by KTMainWindow's view-region and
  // connect the widget to your document to display document contents.

  /*view = new GraView(this);
  doc->addView(view);
  setCentralWidget(view);
  setCaption(doc->URL().fileName(),false);  */
  
  //myframe=new QFrame(this);
  //myframe->setGeometry(50,50,400,400);
  //test= new KPushButton("Test",this);
  //test->setGeometry(25,25,300,300);
  myCanvas=new QCanvas(800,400);//1000,1000);          
  //myCanvas->resize(100,100);
  myCanvasView = new QCanvasViewMouse(this);//view);
  //view->setCentralWidget(myCanvasView);
  myCanvasView->setCanvas(myCanvas);
  myCanvasView->setGeometry(0,0,800,400);
  setCentralWidget(myCanvasView);

  
  
  
  kugelanz=4;//100;//100;
  kugel=new MyKugel *[kugelanz];

                          
//  int x1=0,y1=0,x2=115,y2=115;
  int x1=0,y1=0,x2=400,y2=400;

  myrechteck= new RechteckRaum(x1,y1,x2,y2);


  myLine = new QCanvasLine(myCanvas);
    myLine->setPoints(x1,y2,x2,y2);
    myLine->show();
  myLine2 = new QCanvasLine(myCanvas);
    myLine2->setPoints(x2,y1,x2,y2);
    myLine2->show();
  
  /*myLine = new QCanvasLine(myCanvas);
    myLine->setPoints(0,200,300,200);
    myLine->show();
  myLine2 = new QCanvasLine(myCanvas);
    myLine2->setPoints(300,0,300,200);
    myLine2->show();               */

 //------------------------------------------------------------------------ 
    
  for(i=0;i<=kugelanz-1;i++){
    kugel[i] = new MyKugel(myCanvas);//QCanvasEllipse(myCanvas);
    kugel[i]->setX(10+(((int)(i/10))*10));
    kugel[i]->setY(10+(i%10)*10.1);

         kugel[i]->setradius((i%5)+1);
//    kugel[i]->setSize(10,10);
    //kugel[i]->setAngles(0,360);
//    kugel[i]->setEnabled(true);
//    kugel[i]->setVisible(true);
    //myPen = new QPen(red,2);
    kugel[i]->setPen(QPen(black,3,SolidLine));//myPen);
    kugel[i]->setBrush( QBrush( red,SolidPattern ) );
    kugel[i]->show();
   // geschw[i]=0;            
    //winkel=46;
   // winkel[i]=i;
    kugel[i]->setvel(0);
    kugel[i]->setwinkel(i);
    kugel[i]->setmasse(1);
    kugel[i]->setradius(2);

//    geschwneu[i]=0;
//    winkelneu[i]=-1000;
 //   partner[i]=-1;
  }
  kugel[1]->setBrush( QBrush( blue,SolidPattern ) );
    kugel[1]->setX(105);
    kugel[1]->setY(5);
    kugel[1]->setsolid(true);
    kugel[1]->setladung(50);
    kugel[2]->setladung(-50);
    kugel[3]->setladung(-50);

   // kugel[50]->setsolid(true);    
    kugel[2]->setBrush( QBrush( yellow,SolidPattern ) );
    //kugel[2]->setX(5);
    //kugel[2]->setY(105);
    //kugel[2]->setX(40);
    kugel[3]->setBrush( QBrush( green,SolidPattern ) );
    //kugel[3]->setX(150);    
  //masse[1]=1;
     //kugel[1]->setvel(5);
     kugel[3]->setradius(3);
     kugel[3]->setmasse(1);
     
     kugel[1]->setradius(145);
     kugel[1]->setmasse(10);
  //masse[2]=10;
  //masse[3]=10000000;                 
 // winkel[0]=90;    i=0;
 // kugel[1]=0;
  
  //--------------------------------------------

  //kugel[0]->setX(10);
  //kugel[0]->setY(190);
//  kugel[0]->setX(200);
//  kugel[0]->setY(200);
  kugel[2]->setmasse(1);
  kugel[0]->setmasse(1);
 
 
  kugel[1]->setX(200);
  kugel[1]->setY(200);


  kugel[2]->setX(50);//200);
  kugel[2]->setY(195);//50);

  kugel[3]->setX(200);
  kugel[3]->setY(35);

  
  kugel[0]->setX(200);
  kugel[0]->setY(350);


  kugel[3]->setwinkel(0);
  kugel[3]->setvel(7);
    
  kugel[2]->setwinkel(0);
  kugel[2]->setvel(2);

  kugel[0]->setwinkel(180);
  kugel[0]->setvel(1);

  
  //winkel[0]=315; //   i=0;
  kugel[1]->setwinkel(226);      
  //winkel[0]=90;

  //-----------------------------------
      // unten rechts

//  kugel[0]->setX(150);
//  kugel[0]->setY(150);

  //winkel[0]=225;
  //-----------------------------------
  //-----------------------------------
    //oben links

  //kugel[0]->setX(10);
  //kugel[0]->setY(10);

  //winkel[0]=45;
  //geschw[0]=0;
  //geschw[1]=0;
  //-----------------------------------
  //-----------------------------------
      //unten links

  //kugel[0]->setX(10);
  //kugel[0]->setY(190);

  //winkel[0]=315;
  //-----------------------------------
  

              
  //geschw[0]=2.5;
  //geschw[1]=0;
  //geschw[0]=2.5;
  //geschw[1]=2.5;
  //geschw[2]=5;
  //geschw[3]=5;  
  //if(kugel[i]->x()>200){winkel=225;}
  //if(kugel[i]->x()<0){winkel=45;}
  //if(kugel[i]->y()>300){winkel=315;}
  //if(kugel[i]->y()<0){winkel=135;}

//  editCopy->setEnable(true);
  /*winkel=0;
  int i;
  richtung=true;
  for(i=0;i<=19;i++){
  kugel[i] = new QCanvasEllipse(myCanvas);
  kugel[i]->setX(20+i*11);
  kugel[i]->setY(30);
  kugel[i]->setSize(10,10);
  kugel[i]->setPen(QPen(black,3,SolidLine));//myPen);
  kugel[i]->setBrush( QBrush( blue,SolidPattern ) );
  kugel[i]->setEnabled(true);
  kugel[i]->setVisible(true);

  kugel[i]->show();       }    */
  //QTimer QTimer = new ::QTimer();
  //myTimer = (new QTimer( &this ,"MyTimer"));
//  connect( myTimer, SIGNAL(timeout()), this, SLOT(slotEditCopy()) );
//  myTimer->start( 2000, TRUE ); // 2 seconds single-shot timer
  
  
  //doc->newDocument();





}


void GraApp::openDocumentFile(const KURL & url)
{
  slotStatusMsg(i18n("Opening file..."));

  doc->openDocument( url);
  fileOpenRecent->addURL( url );
  slotStatusMsg(i18n("Ready."));
  //KTextEdit test = new KTextEdit(this,"Test");
  //test= new KPushButton("aasdbl",this);
  //this.
}


//GraDoc *getDocument() const;
GraDoc *GraApp::getDocument() const
{
  return doc;
}

void GraApp::saveOptions()
{
  config->setGroup("General Options");
  config->writeEntry("Geometry", size());
  config->writeEntry("Show Toolbar", viewToolBar->isChecked());
  config->writeEntry("Show Action Toolbar", viewActionToolBar->isChecked());
  config->writeEntry("Show Statusbar",viewStatusBar->isChecked());
  config->writeEntry("ToolBarPos", (int) toolBar("mainToolBar")->barPos());
  config->writeEntry("ActionToolBarPos", (int) toolBar("mainToolBar")->barPos());

  fileOpenRecent->saveEntries(config,"Recent Files");
}


void GraApp::readOptions()
{

  config->setGroup("General Options");

  // bar status settings
  bool bViewToolbar = config->readBoolEntry("Show Toolbar", true);
  viewToolBar->setChecked(bViewToolbar);
  slotViewToolBar();

  bool bViewActionToolbar = config->readBoolEntry("Show Action Toolbar", true);
  viewActionToolBar->setChecked(bViewActionToolbar);
  slotViewActionToolBar();
  
  
  bool bViewStatusbar = config->readBoolEntry("Show Statusbar", true);
  viewStatusBar->setChecked(bViewStatusbar);
  slotViewStatusBar();


  // bar position settings
  KToolBar::BarPosition toolBarPos;
  toolBarPos=(KToolBar::BarPosition) config->readNumEntry("ToolBarPos", KToolBar::Top);
  toolBar("mainToolBar")->setBarPos(toolBarPos);
  // bar position settings
  KToolBar::BarPosition actiontoolBarPos;
  actiontoolBarPos=(KToolBar::BarPosition) config->readNumEntry("ActionToolBarPos", KToolBar::Top);
  toolBar("actionToolBar")->setBarPos(actiontoolBarPos);

  
  // initialize the recent file list
  fileOpenRecent->loadEntries(config,"Recent Files");

  QSize size=config->readSizeEntry("Geometry");
  if(!size.isEmpty())
  {
    resize(size);
  }
}

void GraApp::saveProperties(KConfig *_cfg)
{
  if(doc->URL().fileName()!=i18n("Untitled") && !doc->isModified())
  {
    // saving to tempfile not necessary

  }
  else
  {
    KURL url=doc->URL();
    _cfg->writeEntry("filename", url.url());
    _cfg->writeEntry("modified", doc->isModified());
    QString tempname = kapp->tempSaveName(url.url());
    QString tempurl= KURL::encode_string(tempname);
    KURL _url(tempurl);
    doc->saveDocument(_url);
  }
}


void GraApp::readProperties(KConfig* _cfg)
{
  QString filename = _cfg->readEntry("filename", "");
  KURL url(filename);
  bool modified = _cfg->readBoolEntry("modified", false);
  if(modified)
  {
    bool canRecover;
    QString tempname = kapp->checkRecoverFile(filename, canRecover);
    KURL _url(tempname);

    if(canRecover)
    {
      doc->openDocument(_url);
      doc->setModified();
      setCaption(_url.fileName(),true);
      QFile::remove(tempname);
    }
  }
  else
  {
    if(!filename.isEmpty())
    {
      doc->openDocument(url);
      setCaption(url.fileName(),false);
    }
  }
}

bool GraApp::queryClose()
{
  
  return doc->saveModified();
}

bool GraApp::queryExit()
{
  myTimer->stop();
  saveOptions();
  return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void GraApp::slotFileNewWindow()
{
  slotStatusMsg(i18n("Opening a new application window..."));

  GraApp *new_window= new GraApp();
  new_window->show();

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileNew()
{
  slotStatusMsg(i18n("Creating new document..."));

  if(!doc->saveModified())
  {
     // here saving wasn't successful

  }
  else
  {
    doc->newDocument();
    setCaption(doc->URL().fileName(), false);
  }

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileOpen()
{
  slotStatusMsg(i18n("Opening file..."));

  if(!doc->saveModified())
  {
     // here saving wasn't successful

  }
  else
  {
    KURL url=KFileDialog::getOpenURL(QString::null,
        i18n("*.kph|KPhysics Files\n*|All files"), this, i18n("Open File..."));
    if(!url.isEmpty())
    {
      doc->openDocument(url);
      setCaption(url.fileName(), false);
      fileOpenRecent->addURL( url );
    }
  }
  //initView2();
  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileOpenRecent(const KURL& url)
{
  slotStatusMsg(i18n("Opening file..."));

  if(!doc->saveModified())
  {
     // here saving wasn't successful
  }
  else
  {
    doc->openDocument(url);
    setCaption(url.fileName(), false);
  }
  //initView2();
  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileSave()
{
  slotStatusMsg(i18n("Saving file..."));

  doc->saveDocument(doc->URL());

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileSaveAs()
{
  slotStatusMsg(i18n("Saving file with a new filename..."));

  KURL url=KFileDialog::getSaveURL(QDir::currentDirPath(),
        i18n("*.kph|KPhysics Files\n*|All files"), this, i18n("Save as..."));
  if(!url.isEmpty())
  {
    doc->saveDocument(url);
    fileOpenRecent->addURL(url);
    setCaption(url.fileName(),doc->isModified());
  }

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileClose()
{
  slotStatusMsg(i18n("Closing file..."));

  close();

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFilePrint()
{
  slotStatusMsg(i18n("Printing..."));
	QPrinter printer;
//	printer.addDialogPage(new KPrintDialogPage());
  //QPrinter printer;
  if (printer.setup(this))
  {
//    printer.newPage();
    QPainter printpainter;
    printpainter.begin(&printer);
    //theApp->myCanvas->drawArea( QRect(0,0,400,400), &printpainter );
    //theApp->myCanvas->drawArea(theApp->myCanvas->rect(),&printpainter);
    QPixmap pix(400, 400);
    QPainter pixp(&pix);
    this->myCanvas->drawArea(QRect(0,0,400,400)/*course->rect()*/, &pixp);
    printpainter.drawPixmap(0, 0, pix);
    
    printpainter.setPen(QPen(black, 2));
    printpainter.drawRect(QRect(0,0,400,400));
//    printpainter.resetXForm();
    printpainter.end();
 //   view->print(&printer);
  }

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotFileQuit()
{
  slotStatusMsg(i18n("Exiting..."));
  saveOptions();
  // close the first window, the list makes the next one the first again.
  // This ensures that queryClose() is called on each window to ask for closing
  KMainWindow* w;
  if(memberList)
  {
    for(w=memberList->first(); w!=0; w=memberList->first())
    {
      // only close the window if the closeEvent is accepted. If the user presses Cancel on the saveModified() dialog,
      // the window and the application stay open.
      if(!w->close())
	break;
    }
  }
}

void GraApp::slotEditCut()
{
  slotStatusMsg(i18n("Cutting selection..."));

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotEditCopy()
{
  slotStatusMsg(i18n("Copying selection to clipboard..."));

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotTimer()
{
  //slotShowLadungsFeld();
  //slotStatusMsg(i18n("Copying selection to clipboard..."));
  //int winkel=180;
  //i <= 3 ? i++ : i=-3;
  //kugel[1]->setvel(0);
  //winkel[0]+=1;
  //winkel[1]-=1;
  //winkel[2]+=2;
  //winkel[3]-=2;
  double newx;
  double newy;
  //kugel[i]->setX(kugel[i]->x()+cos(winkel*2*M_PI/360)*10);
  //kugel[i]->setY(kugel[i]->y()+sin(winkel*2*M_PI/360)*10);
  //double r=kugel[0]->getradius();
  
 for(int i=0;i<=kugelanz-1;i++){
  // Reibung---------------------- 
  if (reibung) {
    kugel[i]->setvel(kugel[i]->getvel()*0.96);
    if(kugel[i]->getvel()<0.1) { kugel[i]->setvel(0);}
  }
    
  //newx=kugel[i]->x()+cos(winkel*2*M_PI/360)*geschw;
  //newy=kugel[i]->y()+sin(winkel*2*M_PI/360)*geschw;
  //

  //kugel[i]->setwinkel(kugel[i]->getwinkel()+1);
  
  
  // Erdgravitation--------------
  if (erdgravitation) {
  
    kugel[i]->beschl(0.1,0.1);  
    //Vector *vec = new Vector(Point(0,0.1),Point(-0.1,0));
    //kugel[i]->beschl(*vec);
    //delete vec;
  }
      
      
  //Gravitation--------------- Super Langsam ------------------- !!!!

  if (gravitation) {
    for (int j=0;j<=kugelanz-1;j++){

      if (i==j){j++;}
      if (j>=kugelanz) break;
      
      
      
      double vx,vy;
      
      vx=kugel[i]->x()-kugel[j]->x();
      vy=kugel[i]->y()-kugel[j]->y();
      double wink,vel;
      vel=hypot(vx,vy);
      wink=atan2(vx,vy);
      vel=(kugel[j]->getmasse()*kugel[i]->getmasse())/pow(vel,2)/kugel[i]->getmasse();
      vx=sin(wink)*vel;
      vy=cos(wink)*vel;
      /*Vector *vec = new Vector(*(new Point(kugel[j]->x(),kugel[j]->y())),
                            *(new Point(kugel[i]->x(),kugel[i]->y())));
      vec->setMagnitude((-kugel[j]->getladung()*kugel[i]->getladung())/pow(vec->magnitude(),2)/kugel[i]->getmasse());
      */   
      
      kugel[i]->beschl(vx,vy);
      
      /*Vector *vec = new Vector((Point(0,0)),(Point(vx,vy)));
      
      kugel[i]->beschl(*vec);
         
      delete vec;*/
      
      
      //vec->setMagnitude((-kugel[j]->getladung()*kugel[i]->getladung())/pow(vec->magnitude(),2)/kugel[i]->getmasse());
      
      
      
      
      /*Vector *vec = new Vector(*(new Point(kugel[j]->x(),kugel[j]->y())),
                            *(new Point(kugel[i]->x(),kugel[i]->y())));
      //*vec*=0.1;
      vec->setMagnitude((kugel[j]->getmasse()*kugel[i]->getmasse())/pow(vec->magnitude(),2)/kugel[i]->getmasse());
         
      kugel[i]->beschl(*vec);*/
      //delete vec;
    } 
  }

  //Ladungen--------------- Super Langsam ------------------- !!!!

  if (elec) {
    for (int j=0;j<=kugelanz-1;j++){

      if (i==j){j++;}
      if (j>=kugelanz) break;
      double vx,vy;
      
      vx=kugel[j]->x()-kugel[i]->x();
      vy=kugel[j]->y()-kugel[i]->y();
      double wink,vel;
      vel=hypot(vx,vy);
      wink=atan2(vx,vy);
      vel=(kugel[j]->getladung()*kugel[i]->getladung())/pow(vel,2)/kugel[i]->getmasse();
      vx=sin(wink)*vel;
      vy=cos(wink)*vel;
      /*Vector *vec = new Vector(*(new Point(kugel[j]->x(),kugel[j]->y())),
                            *(new Point(kugel[i]->x(),kugel[i]->y())));
      vec->setMagnitude((-kugel[j]->getladung()*kugel[i]->getladung())/pow(vec->magnitude(),2)/kugel[i]->getmasse());
      */   
      kugel[i]->beschl(vx,vy);
      
      //delete vec;
    } 
  }

  
  
  double altx=kugel[i]->x();
  double alty=kugel[i]->y();  
  kugel[i]->setX(kugel[i]->x()+cos(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel());
  kugel[i]->setY(kugel[i]->y()+sin(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel());


  
  // 270
  /*if(newx>=300-r){
    //if(winkel>180){winkel-=360;}
    if(winkel<0){winkel-=(270+winkel)*2;}    
    if(winkel>0){winkel+=(90-winkel)*2;}
    if(winkel==0){winkel+=180;}
    newx=300-r;
  }
  
  // 90
  if(newx<=0+r){
    if(winkel<180){winkel-=(90+winkel)*2;}    
    if(winkel>180){winkel+=(270-winkel)*2;}
    if(winkel==180){winkel+=180;}
    newx=(0+r);
  }
  
  // 0
  if(newy>=200-r){
    if(winkel<90){winkel-=(0+winkel)*2;}
    if(winkel>90){winkel+=(180-winkel)*2;}
    if(winkel==90){winkel+=180;}
    newy=(200-r);
  }
  
  // 180
  if(newy<=0+r){
    if(winkel<270){winkel-=(180+winkel)*2;}
    if(winkel>270){winkel+=(360-winkel)*2;}
    if(winkel==270){winkel+=180;}    
    newy=(0+r);
  }
  
  if (winkel>=360){winkel-=360;}
  if (winkel<=0){winkel+=360;}

  kugel[i]->setwinkel(winkel);    */
  myrechteck->Kantenstoss(kugel[i]);
  newx=kugel[i]->x();
  newy=kugel[i]->y();
  

  

  
// Kugelstoss
  // if (i==0) {

  int treffen=-1;
        double stosswinkel,winkel1,winkel2;
          double vNewAnt1,vNewAnt2,vAnt1,vAnt2,v1,v2;    
    for (int j=0;j<=kugelanz-1;j++){
      
      if (i==j){j++;}
      //if ((partner[i]==j)||(partner[j]==i)){
      /*if ((partner[i]==j+100)||(partner[j]==i+100)){
        //kugel[j]->setX(kugel[j]->x()+0.1-((rand()%20)/10));
        // kugel[j]->setY(kugel[j]->y()+0.1-((rand()%20)/10));
         partner[j]=-1;partner[i]=-1;
         kugel[j]->setX(kugel[j]->x()+cos(kugel[j]->getwinkel()*2*M_PI/360)*r);
         kugel[j]->setY(kugel[j]->y()+sin(kugel[j]->getwinkel()*2*M_PI/360)*r);//geschw[j]*2);
         j++;}  */
      if (j>=kugelanz) break;
      //if( (((newx-kugel[j]->x()*newx-kugel[j]->x())) /*+((newy-kugel[j]->y())^2) )^(1/2)*/<=(double)(r*2)){


      if( hypot(newx-kugel[j]->x(),newy-kugel[j]->y())<(kugel[i]->getradius()+kugel[j]->getradius())){
        //treffen=true;
	
	//-------------------------------Normaler Sto----------------------------------------------------------------------------
          if(!kugel[j]->getsolid()){         
		   //winkel ermitteln ----------------------------------------------------------------------
                            //-------double stosswinkel,winkel1,winkel2;
            stosswinkel=atan2((kugel[j]->y()-newy),(kugel[j]->x()-newx));
            stosswinkel=(stosswinkel/M_PI)*180;
            if (stosswinkel<0){stosswinkel+=360;}        
                            //if (this->i==0) {slotStatusMsg(QString::number(stosswinkel));(this->i)++; }        
                   // Geschwinkigkeitsanteile ermitteln  ---------------------------------------------------
                            //----------- double vNewAnt1,vNewAnt2,vAnt1,vAnt2,v1,v2;
                            //double m1=1,m2=1;
            double m1=kugel[i]->getmasse(),m2=kugel[j]->getmasse();
            // 1:                                               
               v1=kugel[i]->getvel()*sin((kugel[i]->getwinkel()-stosswinkel)/360*2*M_PI);
            vAnt1=kugel[i]->getvel()*cos((kugel[i]->getwinkel()-stosswinkel)/360*2*M_PI);
            // 2
               v2=kugel[j]->getvel()*sin((kugel[j]->getwinkel()-stosswinkel)/360*2*M_PI);
            vAnt2=kugel[j]->getvel()*cos((kugel[j]->getwinkel()-stosswinkel)/360*2*M_PI);
        /*if (this->i==0) 
        {slotStatusMsg("1 v/a:"+QString::number(geschw[i])+"/"+QString::number(winkel[i])+":"+QString::number(v1)+"/"+QString::number(vAnt1)+
        " 2 v/a: "+QString::number(geschw[j])+"/"+QString::number(winkel[j])+":"+QString::number(v2)+"/"+QString::number(vAnt2)); (this->i)++;}
        */
	
                   // neue Geschwindigkeiten berechnen  ---------------------------------------------------
                
          vNewAnt1= (m1-m2)/(m1+m2)*vAnt1+(2*m2)/(m1+m2)*vAnt2;
          vNewAnt2= (m1*(vAnt1-vNewAnt1)+m2*vAnt2)/m2;
       /* if ((this->i==0)||(this->i==0))
        {slotStatusMsg("1/2:"+QString::number(vAnt1)+"/"+QString::number(vAnt2)+"::1N/2N:"+QString::number(vNewAnt1)+"/"+QString::number(vNewAnt2));(this->i)++;}*/

            
        // Geschwindigkeiten zusammenrechnen ----------------------------------------------------                   
          // 1
              winkel1=atan2(v1,vNewAnt1);
              v1=hypot(vNewAnt1,v1);
            //if(v1<0){winkel=(-winkel);}
        //if (this->i==0) {slotStatusMsg(QString::number(vNewAnt1)+"/"+QString::number(v1)); (this->i)++;}

                        
          // 2
            winkel2=atan2(v2,vNewAnt2);
            v2=hypot(vNewAnt2,v2);   
            winkel1=winkel1/M_PI*180+stosswinkel;
            winkel2=winkel2/M_PI*180+stosswinkel;
            if (this->i==0) {slotStatusMsg(QString::number(winkel2)+"/"+QString::number(v2)); /*winkel2=45;*/(this->i)++;}
                                                                              
        // ----------------------------------------- 

      //  kugel[i]->setX(kugel[i]->x()-cos(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel());
      //  kugel[i]->setY(kugel[i]->y()-sin(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel());

        //kugel[j]->setX(kugel[j]->x()-cos(kugel[j]->getwinkel()*2*M_PI/360)*kugel[j]->getvel());
        //kugel[j]->setY(kugel[j]->y()-sin(kugel[j]->getwinkel()*2*M_PI/360)*kugel[j]->getvel());

        
      //   kugel[i]->setwinkel(winkel1);
      //   kugel[j]->setwinkel(winkel2);
      //   kugel[i]->setvel(v1);
      //   kugel[j]->setvel(v2);
         
         /*winkel[i]=winkel1;
         winkel[j]=winkel2;
         geschw[i]=v1;
         geschw[j]=v2; */
         //partner[i]=j;
         treffen=j;
         //if ((partner[i]==j)||(partner[j]==i)){
           //partner[i]+=100;
           //partner[j]+=100;
         //} else {
           //partner[i]=-1;
           //partner[j]=-1;
         //}   
         //geschwneu[i]=j;
         //winkelneu[i]=winkel1;

         //geschwneu[j]=v2;
         //winkelneu[j]=winkel2;

         //newx=newx+cos(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel()*1.1;
         //newy=newy+sin(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel()*1.1;
         //kugel[j]->setX(kugel[j]->x()+cos(kugel[j]->getwinkel()*2*M_PI/360)*kugel[j]->getvel()*1.1);
         //kugel[j]->setY(kugel[j]->y()+sin(kugel[j]->getwinkel()*2*M_PI/360)*kugel[j]->getvel()*1.1);


         //newx+=-0.1+((rand()%20)/10);
         //newy+=-0.1+((rand()%20)/10);
         //kugel[j]->setX(kugel[j]->x()+0.1-((rand()%20)/10));
         //kugel[j]->setY(kugel[j]->y()+0.1-((rand()%20)/10));
         /*winkel[i]=winkel1;
         winkel[j]=winkel2;
         geschw[i]=v1;
         geschw[j]=v2;  */
         
//         new


       } else  {  // "fester Sto/ j fest"
            stosswinkel=atan2((kugel[j]->y()-newy),(kugel[j]->x()-newx));
            stosswinkel=(stosswinkel/M_PI)*180;
            if (stosswinkel<0){stosswinkel+=360;}        
            
	    // Nicht optimal !!!!!!---------------------------
	    double m1=kugel[i]->getmasse(),m2=kugel[j]->getmasse();
            // 1:                                               
               v1=kugel[i]->getvel()*sin((kugel[i]->getwinkel()-stosswinkel)/360*2*M_PI);
            vAnt1=kugel[i]->getvel()*cos((kugel[i]->getwinkel()-stosswinkel)/360*2*M_PI);
            // 2
               v2=kugel[j]->getvel()*sin((kugel[j]->getwinkel()-stosswinkel)/360*2*M_PI);
            vAnt2=kugel[j]->getvel()*cos((kugel[j]->getwinkel()-stosswinkel)/360*2*M_PI);
            v2=0;
	    vAnt2=0;
          //vNewAnt1= (m1-m2)/(m1+m2)*vAnt1+(2*m2)/(m1+m2)*vAnt2;
          //vNewAnt2= (m1*(vAnt1-vNewAnt1)+m2*vAnt2)/m2;
	  m2= 1000000;
	  vNewAnt1= (m1-m2)/(m1+m2)*vAnt1+(2*m2)/(m1+m2)*vAnt2;
          vNewAnt2= (m1*(vAnt1-vNewAnt1)+m2*vAnt2)/m2;
          
          winkel1=atan2(v1,vNewAnt1);
	  winkel1=2*kugel[i]->getwinkel()-stosswinkel+180;
	  winkel1=reflexion(kugel[i]->getwinkel(),stosswinkel);
	  if(testdebug==0)
	  {
	  slotStatusMsg(QString::number(kugel[i]->getwinkel())+"/"+QString::number(stosswinkel)+"/"+QString::number(winkel1)); 
	  ++testdebug;
	  }
	    //--------------------------------------------------
	       
	            
            treffen=j;
	    //winkel1=kugel[i]->getwinkel()+2*stosswinkel;
	    v1= kugel[i]->getvel();
	    winkel2=kugel[j]->getwinkel();
	    v2 = kugel[j]->getvel();  
       }
         
     }
     if (treffen!=-1) break;
     
   // }
  }
    if (treffen>-1 ) {
    kugel[i]->setX(kugel[i]->x()-cos(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel());
        kugel[i]->setY(kugel[i]->y()-sin(kugel[i]->getwinkel()*2*M_PI/360)*kugel[i]->getvel());

        //kugel[j]->setX(kugel[j]->x()-cos(kugel[j]->getwinkel()*2*M_PI/360)*kugel[j]->getvel());
        //kugel[j]->setY(kugel[j]->y()-sin(kugel[j]->getwinkel()*2*M_PI/360)*kugel[j]->getvel());


         kugel[i]->setwinkel(winkel1);
         kugel[i]->setvel(v1);
         kugel[treffen]->setwinkel(winkel2);
         kugel[treffen]->setvel(v2);
    }  
  

  
  //kugel[i]->setX(newx);
  //kugel[i]->setY(newy);
  if (kugel[i]->getwinkel()>=360) {kugel[i]->setwinkel(kugel[i]->getwinkel()-360);}
  if (kugel[i]->getwinkel()<=0){kugel[i]->setwinkel(kugel[i]->getwinkel()+360);}


 }
  myCanvas->update();

 /*for(int i=0;i<=kugelanz-1;i++){
     if(winkelneu[i]!=-1000){
         winkel[i]=winkelneu[i];
         //winkel[j]=winkel2;
         geschw[i]=geschwneu[i];
         //geschw[j]=v2;

         geschwneu[i]=0;
         winkelneu[i]=-1000;

   }
  
 }  */ 
  //slotStatusMsg(i18n("Ready."));
}

void GraApp::slotEditPaste()
{
  slotStatusMsg(i18n("Inserting clipboard contents..."));

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotViewToolBar()
{
  slotStatusMsg(i18n("Toggling toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
  if(!viewToolBar->isChecked())
  {
    toolBar("mainToolBar")->hide();
  }
  else
  {
    toolBar("mainToolBar")->show();
  }

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotViewActionToolBar()
{
  slotStatusMsg(i18n("Toggling toolbar..."));
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
  if(!viewToolBar->isChecked())
  {
    toolBar("actionToolBar")->hide();
  }
  else
  {
    toolBar("actionToolBar")->show();
  }

  slotStatusMsg(i18n("Ready."));
}

void GraApp::slotViewStatusBar()
{
  slotStatusMsg(i18n("Toggle the statusbar..."));
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
  if(!viewStatusBar->isChecked())
  {
    statusBar()->hide();
  }
  else
  {
    statusBar()->show();
  }

  slotStatusMsg(i18n("Ready."));
}


void GraApp::slotStatusMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG);
}

/** If someone resizes the window */
void GraApp::slotResize(){
  //slotStatusMsg(i18n("Ficken"));


}
/** void Canvas::resizeEvent( QResizeEvent *e )
{
    QWidget::resizeEvent( e );

    int w = width() > buffer.width() ?
            width() : buffer.width();
    int h = height() > buffer.height() ?
            height() : buffer.height();

    QPixmap tmp( buffer );
    buffer.resize( w, h );
    buffer.fill( colorGroup().base() );
    bitBlt( &buffer, 0, 0, &tmp, 0, 0, tmp.width(), tmp.height() );
}
 */
void GraApp::resizeEvent(QResizeEvent *e){
    QWidget::resizeEvent( e );
 /* slotStatusMsg(i18n("Arsch"));
    myCanvasView->setGeometry(0,0,
    width()
    -toolBar("mainToolBar")->y()
    -statusBar()->y()
   // -menubar()->x()
    ,height()
    -toolBar("mainToolBar")->height()
    -statusBar()->height()
    //-menubar()->y());
    */
    //toolBar("mainToolBar")->setBarPos(toolBarPos);
    //statusBar()->hide();
    //menubar();
 //myCanvas->setGeometry(0,0,width(),height());
  //int width () const
//int height () const


}
/** No descriptions */
void GraApp::slotTimerStart() {
  //KMessageBox::error(myCanvasView,QString::number(this->winkel[0])+" "+QString::number(this->kugel[0]->x())+" "+QString::number(this->kugel[0]->y()));
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
    

  /*  if (myTimer->isActive()){                          
    myTimer->stop();
  }else{ */
    myTimer->start( 25, FALSE );
  //  }
  actionTimerStart->setEnabled(false);
  actionTimerStop->setEnabled(true);

}

/** No descriptions */
void GraApp::slotGravitationAn(){
  gravitation=!gravitation;
  actionGravitationAn->setEnabled(false);
  actionGravitationAus->setEnabled(true);  
}
void GraApp::slotTimerStop(){
  //KMessageBox::error(myCanvasView,QString::number(this->winkel[0])+" "+QString::number(this->kugel[0]->x())+" "+QString::number(this->kugel[0]->y()));
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                                              

 // if (myTimer->isActive()){
    myTimer->stop();
 /* }else{
    myTimer->start( 25, FALSE );
  } */

  actionTimerStart->setEnabled(true);
  actionTimerStop->setEnabled(false);
  
}

/** No descriptions */
void GraApp::slotGravitationAus(){
  gravitation=!gravitation;
  actionGravitationAn->setEnabled(true);
  actionGravitationAus->setEnabled(false);  
}

/** No descriptions */
void GraApp::slotShowLadungsFeld(){
      //myCanvas->setBackgroundColor(Qt::black);//QColor(150,150,150));
      /*for (int i=0;i<256/2;i++){
        myImage->setColor ( i, qRgb(i*2,0,0)); 
      }
      for (int i=0;i<256/2;i++){
        myImage->setColor ( 256/2+i, qRgb(0,i*2,0)); 
      }*/
goRouteladungen();
          
      for (int i=0;i<400;i++){
        for (int j=0;j<400;j++){
	  double ges=0;
	  for(int k=0;k<=kugelanz-1;k++){
             //Gravitation--------------- Super Langsam ------------------- !!!!
            double vx,vy;  
            vx=kugel[k]->x()-i;
            vy=kugel[k]->y()-j;
            double vel;
            vel=hypot(vx,vy);
            vel=(kugel[k]->getladung())/vel;//pow(vel,2);
	    ges+=vel;
          }
	   
           myImage->setPixel ( i,j,(int)(ges*1000)+100);//(i*j)/400);//QColor(i/2,j/2,0) ) ;
          //myImage->setPixel ( 1,1,1);//QColor(i/2,j/2,0) ) ;
      
        }
      }     
      myCanvas->setBackgroundPixmap(QPixmap(*myImage));
      
      
      //delete myImage;
  //  }
  //}
  //myCanvas->update();
  //KMessageBox::error(this,"Blbal");   
}

const bool& GraApp::geteditable(){
  return editable;
}


/** No descriptions */
void GraApp::slotShowGravFeld(){
      //myCanvas->setBackgroundColor(Qt::black);//QColor(150,150,150));
      /*for (int i=0;i<256/2;i++){
        myImage->setColor ( i, qRgb(i*2,0,0)); 
      }
      for (int i=0;i<256/2;i++){
        myImage->setColor ( 256/2+i, qRgb(0,i*2,0)); 
      }*/

      goRoutegravitation();
          
      for (int i=0;i<400;i++){
        for (int j=0;j<400;j++){
	  double ges=0;
	  for(int k=0;k<=kugelanz-1;k++){
             //Gravitation--------------- Super Langsam ------------------- !!!!
            double vx,vy;  
            vx=kugel[k]->x()-i;
            vy=kugel[k]->y()-j;
            double vel;
            vel=hypot(vx,vy);
            vel=(kugel[k]->getmasse())/vel;//pow(vel,2);
	    ges+=vel;
          }
	   
           myImage->setPixel ( i,j,(int)(ges*1000)+100);//(i*j)/400);//QColor(i/2,j/2,0) ) ;
          //myImage->setPixel ( 1,1,1);//QColor(i/2,j/2,0) ) ;
      
        }
      }     
      myCanvas->setBackgroundPixmap(QPixmap(*myImage));
      //delete myImage;
  //  }
  //}
  //myCanvas->update();
  //KMessageBox::error(this,"Blbal");   
}

void GraApp::slotEditOnOff(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                //myCanvasView->setMasse(editMasse->currentText().toInt());         
		//editMasse->setCurrentItem(0);                     
                  //if(editonoff.isChecked()){
		    
		  //}
		  editmenu->setEnabled(editonoff->isChecked());
		  if (editonoff->isChecked()){
		    editable=true;
		    deleteable=false;
		    newable=false;
		  } else {
		    editable=false;
		    deleteable=false;
		    newable=false;
		  }
		  myCanvasView->doonoff();
		                     

 // if (myTimer->isActive()){
  
}

void GraApp::slotEditNew(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                //myCanvasView->setMasse(editMasse->currentText().toInt());         
		//editMasse->setCurrentItem(0);                     
                  //if(editonoff.isChecked()){
		    
		  //}
		  //editmenu->setEnabled(editonoff->isChecked());
		  if (editonoff->isChecked()){
		    editable=false;
		    deleteable=false;
		    newable=true;
		  } else {
		    editable=false;
		    deleteable=false;
		    newable=false;
		  

		  } myCanvasView->doonoff();
		 	                   

 // if (myTimer->isActive()){
  
}

void GraApp::slotEditEdit(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                //myCanvasView->setMasse(editMasse->currentText().toInt());         
		//editMasse->setCurrentItem(0);                     
                  //if(editonoff.isChecked()){
		    
		  //}
		  if (editonoff->isChecked()){
		    editable=true;
		    deleteable=false;
		    newable=false;
		  } else {
		    editable=false;
		    deleteable=false;
		    newable=false;
		  
		  } myCanvasView->doonoff();

 // if (myTimer->isActive()){
  
}
void GraApp::slotEditDelete(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                //myCanvasView->setMasse(editMasse->currentText().toInt());         
		//editMasse->setCurrentItem(0);                     
                  //if(editonoff.isChecked()){
		    
		  //}
		  editmenu->setEnabled(editonoff->isChecked());
		  if (editonoff->isChecked()){
		    editable=false;
		    deleteable=true;
		    newable=false;
		  } else {
		    editable=false;
		    deleteable=false;
		    newable=false;
		  }
		  myCanvasView->doonoff();                   

 // if (myTimer->isActive()){
  
}



void GraApp::slotEditMasse(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                myCanvasView->setMasse(editMasse->currentText().toInt());         
		editMasse->setCurrentItem(0);                     
                                    

 // if (myTimer->isActive()){
  
}

void GraApp::slotEditRadius(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                myCanvasView->setRadius(editRadius->currentText().toInt());                              
        	editRadius->setCurrentItem(0);                     
                                    

 // if (myTimer->isActive()){
  
}
void GraApp::slotEditLadung(){
  
  //KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
                myCanvasView->setLadung(editLadung->currentText().toInt());                              
        	editLadung->setCurrentItem(0);                     
                                    

 // if (myTimer->isActive()){
  
}

void GraApp::slotWidgetClick(){
  
  KMessageBox::error(myCanvasView,testlista->currentText());
  //if( sqrt(exp(newx-kugel[j]->x())+exp(newy-kugel[j]->y()))<=(r*2)){
     //{KMessageBox::error(myCanvasView,QString::number(sqrt(exp(3))));}
//                myCanvasView->bla();                              

 // if (myTimer->isActive()){
  
}


void GraApp::goRouteladungen(){
      srand(rand());
      //myCanvas->setBackgroundColor(Qt::black);//QColor(150,150,150));
      /*for (int i=0;i<256/2;i++){
        myImage->setColor ( i, qRgb(i*2,0,0)); 
      }
      for (int i=0;i<256/2;i++){
        myImage->setColor ( 256/2+i, qRgb(0,i*2,0)); 
      }*/
   int x=10,y=10;
   
   // Feld lschen
  for(int z=0;z<feldanz;z++){  
  //feldKreis[z]
  //feldLine[z]
    delete feldKreis[z];
    delete feldLine[z];
  } 

   
  // while((x>0) && (y>0)){
   
  for(int z=0;z<pow(19,2);z++){  
   // for(int y1=0;y1<20;y1++){         
	 // x=10+(400/20)*x1; y=10+(400/20)*y1 ;  
	  x=15+(400/20)*(z/19); y=15+(400/20)*(z%19) ;  
	    
   	  //for(int k=0;k<=kugelanz-1;k++){
             //Gravitation--------------- Super Langsam ------------------- !!!!
               double vx=0,vy=0;
   	       double ges=0;
	       Vector *res=new Vector(0,0);
	       for(int k=0;k<=kugelanz-1;k++){
	            // Vektoren Aufaddieren:
		    ges=hypot(kugel[k]->x()-(double)x,kugel[k]->y()-(double)y);
		    
                    //vx+=kugel[k]->getladung()/(pow(kugel[k]->x()-(double)x,2));
                    //vy+=kugel[k]->getladung()/(pow(kugel[k]->y()-(double)y,2));
               
	            *res=
		    Vector(kugel[k]->getladung()/(pow(ges,2)),atan2(kugel[k]->x()-(double)x,kugel[k]->y()-(double)y))+*res;
	       }
	       double wink,vel;
               //vel=hypot(vx,vy);
               //wink=atan2(vx,vy);
	       
	       wink=res->direction();
	       if (res->magnitude()==0){wink=((rand()*rand())%316)/100;}
	       delete res;
	       
               //vel=(kugel[j]->getladung()*kugel[i]->getladung())/pow(vel,2)/kugel[i]->getmasse();
	       vel=10;
               vx=sin(wink)*vel;
               vy=cos(wink)*vel;
	      
if ((x+vx)>=400){KMessageBox::error(this,QString::number(z)+"Bl-1-bal"+QString::number(x));vx=400-x-1;} 
if ((y+vy)>=400){KMessageBox::error(this,QString::number(z)+"Bl-2-bal"+QString::number(y+vy));vy=400-y-1;KMessageBox::error(this,QString::number(z)+"Bl-2-bal"+QString::number(y+vy));break;} 
if ((x+vx)<=0){KMessageBox::error(this,QString::number(z)+"Bl-3-bal"+QString::number(x));vx=x+1;} 
if ((x+vx)<=0){KMessageBox::error(this,QString::number(z)+"Bl-4-bal"+QString::number(y));vy=y+1;}

{	       
	       feldLine[z]= new QCanvasLine ( myCanvas );
               feldLine[z]->setPoints ( x, y,x+vx, y+vy );
	       feldLine[z]->setZ(1);
	       feldLine[z]->show();
	       //delete myLinetest;
	       feldKreis[z]= new QCanvasEllipse( 5, 5,myCanvas );
	       feldKreis[z]->setX(x+vx);
	       feldKreis[z]->setY(y+vy);
	       feldKreis[z]->setZ(1);
	       feldKreis[z]->setPen(QPen(black,3,SolidLine));//myPen);
    //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
               feldKreis[z]->setBrush(QBrush(QColor(Qt::black),SolidPattern));

	       feldKreis[z]->show();
	       }
	       /*myLinetest= new QCanvasLine ( myCanvas );
               myLinetest->setPoints ( 0,0,350, 350 );
               myLinetest->show();
               myLinetest->setPen(QPen(black,3,SolidLine));//myPen);
              //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
               myLinetest->setBrush(QBrush(QColor(Qt::black),SolidPattern));
KMessageBox::error(this,"Blbal");
	       	 */      
	       	        
	       x+=vx;
	       y+=vy;
               /*Vector *vec = new Vector(*(new Point(kugel[j]->x(),kugel[j]->y())),
                            *(new Point(kugel[i]->x(),kugel[i]->y())));
                vec->setMagnitude((-kugel[j]->getladung()*kugel[i]->getladung())/pow(vec->magnitude(),2)/kugel[i]->getmasse());
                   */   
              // kugel[i]->beschl(vx,vy);
	  //}
	   }
	   
	   feldanz=400;
           //myImage->setPixel ( x,y,(int)150);//(i*j)/400);//QColor(i/2,j/2,0) ) ;
          //myImage->setPixel ( 1,1,1);//QColor(i/2,j/2,0) ) ;
      
  //      }
     // myCanvas->setBackgroundPixmap(QPixmap(*myImage));
      //delete myImage;
  //  }
  //}
  myCanvas->update();
  //KMessageBox::error(this,"Blbal");   
}

void GraApp::goRoutegravitation(){
      //myCanvas->setBackgroundColor(Qt::black);//QColor(150,150,150));
      /*for (int i=0;i<256/2;i++){
        myImage->setColor ( i, qRgb(i*2,0,0)); 
      }
      for (int i=0;i<256/2;i++){
        myImage->setColor ( 256/2+i, qRgb(0,i*2,0)); 
      }*/
   int x=10,y=10;
   
   // Feld lschen
  for(int z=0;z<feldanz;z++){  
    delete feldKreis[z];
    delete feldLine[z];
  } 

   
  // while((x>0) && (y>0)){
   
  for(int z=0;z<pow(19,2);z++){  
   // for(int y1=0;y1<20;y1++){         
	 // x=10+(400/20)*x1; y=10+(400/20)*y1 ;  
	  x=15+(400/20)*(z/19); y=15+(400/20)*(z%19) ;  
	    
   	  //for(int k=0;k<=kugelanz-1;k++){
             //Gravitation--------------- Super Langsam ------------------- !!!!
               double vx=0,vy=0;
   	       double ges=0;
	       Vector *res=new Vector(0,0);
	       for(int k=0;k<=kugelanz-1;k++){
	            // Vektoren Aufaddieren:
		    ges=hypot(kugel[k]->x()-(double)x,kugel[k]->y()-(double)y);
		    
                    //vx+=kugel[k]->getladung()/(pow(kugel[k]->x()-(double)x,2));
                    //vy+=kugel[k]->getladung()/(pow(kugel[k]->y()-(double)y,2));
               
	            *res=
		    Vector(kugel[k]->getmasse()/(pow(ges,2)),atan2(kugel[k]->x()-(double)x,kugel[k]->y()-(double)y))+*res;
	       }
	       double wink,vel;
               //vel=hypot(vx,vy);
               //wink=atan2(vx,vy);
	       wink=res->direction();
	       delete res;
	       
               //vel=(kugel[j]->getladung()*kugel[i]->getladung())/pow(vel,2)/kugel[i]->getmasse();
	       vel=10;
               vx=sin(wink)*vel;
               vy=cos(wink)*vel;
	      
	       
	       feldLine[z]= new QCanvasLine ( myCanvas );
               feldLine[z]->setPoints ( x, y,x+vx, y+vy );
       	       feldLine[z]->setZ(1);

	       feldLine[z]->setSelected(true);
	       feldLine[z]->show();
	       //delete myLinetest;
	       feldKreis[z]= new QCanvasEllipse( 5, 5,myCanvas );
	       feldKreis[z]->setX(x+vx);
	       feldKreis[z]->setY(y+vy);
       	       feldKreis[z]->setZ(1);

	       feldKreis[z]->setPen(QPen(black,3,SolidLine));//myPen);
    //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
               feldKreis[z]->setBrush(QBrush(QColor(Qt::black),SolidPattern));

	       feldKreis[z]->show();
	       
	       /*myLinetest= new QCanvasLine ( myCanvas );
               myLinetest->setPoints ( 0,0,350, 350 );
               myLinetest->show();
               myLinetest->setPen(QPen(black,3,SolidLine));//myPen);
              //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
               myLinetest->setBrush(QBrush(QColor(Qt::black),SolidPattern));
KMessageBox::error(this,"Blbal");
	       	 */      
	       	        
	       x+=vx;
	       y+=vy;
               /*Vector *vec = new Vector(*(new Point(kugel[j]->x(),kugel[j]->y())),
                            *(new Point(kugel[i]->x(),kugel[i]->y())));
                vec->setMagnitude((-kugel[j]->getladung()*kugel[i]->getladung())/pow(vec->magnitude(),2)/kugel[i]->getmasse());
                   */   
              // kugel[i]->beschl(vx,vy);
	  //}
	   }
	   
	   feldanz=400;
           //myImage->setPixel ( x,y,(int)150);//(i*j)/400);//QColor(i/2,j/2,0) ) ;
          //myImage->setPixel ( 1,1,1);//QColor(i/2,j/2,0) ) ;
      
  //      }
     // myCanvas->setBackgroundPixmap(QPixmap(*myImage));
      //delete myImage;
  //  }
  //}
  myCanvas->update();
  //KMessageBox::error(this,"Blbal");   
}



/*!
    \fn GraApp::reflexion(const double &eingangswinkel, const double &stosswinkel)
 */
double GraApp::reflexion(const double eingangswinkel, const double stosswinkel)
{
    //double stw=wi;
    double ew=eingangswinkel,sw=stosswinkel;
    ew=normalize(ew);
   /* if ((ew>=0) && (ew<=90)){
     return (sw-90)+(sw-90-ew);
    }
    if ((eingangswinkel>90) && (eingangswinkel<=180)){
     return (sw-90)+(sw-90-ew);
    
    }
    if ((eingangswinkel> 180) && (eingangswinkel<=270)){
     return (sw-90)+(sw-90-ew);
    
    }
    if ((eingangswinkel> 270)){
     return (sw-90)+(sw-90-ew);
    
    }
    return -1;*/
    return (sw-90)+(sw-90-ew);
    
}
double GraApp::normalize(const double winkel)
{
    double w=winkel;
    while((w<0) || (w>=360))
    {
     if (w<0){
       w+=360;
     }
      
     if (w>=360){
       w-=360;
     }
    } 
    return w;
}

