/***************************************************************************
                          gradoc.cpp  -  description
                             -------------------
    begin                : Don Nov 20 23:54:54 CET 2003
    copyright            : (C) 2003 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qdir.h>
#include <qwidget.h>

#include <qstring.h>
#include <qstringlist.h>
#include <qtextstream.h>
#include <qfile.h>



// include files for KDE
#include <klocale.h>
#include <kmessagebox.h>
#include <kio/job.h>
#include <kio/netaccess.h>
#include <kstandarddirs.h>

// application specific includes
#include "kphysicsdoc.h"
#include "kphysics.h"
#include "kphysicsview.h"

QList<GraView> *GraDoc::pViewList = 0L;

GraDoc::GraDoc(QWidget *parent, const char *name) : QObject(parent, name)
{
  if(!pViewList)
  {
    pViewList = new QList<GraView>();
  }

  pViewList->setAutoDelete(true);

  kugelanz=0;
}

GraDoc::~GraDoc()
{
}

void GraDoc::addView(GraView *view)
{
  pViewList->append(view);
}

void GraDoc::removeView(GraView *view)
{
  pViewList->remove(view);
}
void GraDoc::setURL(const KURL &url)
{
  doc_url=url;
}

const KURL& GraDoc::URL() const
{
  return doc_url;
}

void GraDoc::slotUpdateAllViews(GraView *sender)
{
  GraView *w;
  if(pViewList)
  {
    for(w=pViewList->first(); w!=0; w=pViewList->next())
    {
      if(w!=sender)
        w->repaint();
    }
  }

}

bool GraDoc::saveModified()
{
  bool completed=true;

  if(modified)
  {
    GraApp *win=(GraApp *) parent();
    int want_save = KMessageBox::warningYesNoCancel(win,
                                         i18n("The current file has been modified.\n"
                                              "Do you want to save it?"),
                                         i18n("Warning"));
    switch(want_save)
    {
      case KMessageBox::Yes:
           if (doc_url.fileName() == i18n("Untitled"))
           {
             win->slotFileSaveAs();
           }
           else
           {
             saveDocument(URL());
       	   };

       	   deleteContents();
           completed=true;
           break;

      case KMessageBox::No:
           setModified(false);
           deleteContents();
           completed=true;
           break;

      case KMessageBox::Cancel:
           completed=false;
           break;

      default:
           completed=false;
           break;
    }
  }

  return completed;
}

void GraDoc::closeDocument()
{
  deleteContents();
}

bool GraDoc::newDocument()
{
  /////////////////////////////////////////////////
  // TODO: Add your document initialization code here
  /////////////////////////////////////////////////
  modified=false;
  doc_url.setFileName(i18n("Untitled"));
  openDocument(locate("appdata", "samples/sample2.kph"));
  return true;
}

bool GraDoc::openDocument(const KURL& url, const char *format /*=0*/)
{
  QString tmpfile;
  KIO::NetAccess::download( url, tmpfile );
  /////////////////////////////////////////////////
  // TODO: Add your document opening code here
  /////////////////////////////////////////////////
  //x,y,r,m,v,w
  //KMessageBox::error(this->parent(),tmpfile);
  GraApp *win=(GraApp *) parent();

  
  
  
    QStringList lines;
    QFile file( tmpfile );
    if ( file.open( IO_ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        int i = 1;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            //printf( "%3d: %s\n", i++, line.latin1() );
            i++;
            lines += line;
        }
	
	if (kugelanz) {
	  int i;
          for(i=0;i<=kugelanz-1;i++){
            delete kugel[i];
          } 
          //delete kugel[0];
          //kugelanz=this->doc->kugelanz;//100;
          //KMessageBox::error(this,QString::number(kugelanz));
          delete [] kugel;
	}
        kugelanz=i/15;///10;//100;
	//KMessageBox::error(win,QString("i anz:" + QString::number(kugelanz) + "/"+ QString::number(i)));
        //delete [] kugel;
        kugel=new MyKugel *[kugelanz];
        file.close();
    }
/*    int i=0;
    kugel[i] = new MyKugel(new QCanvas());//QCanvasEllipse(myCanvas);
    kugel[i]->setX(10);
    kugel[i]->setY(10);
    kugel[i]->setradius(5);
    kugel[i]->setmasse(1);
    kugel[i]->setvel(2);
    kugel[i]->setwinkel(0);
    kugel[i]->setPen(QPen(black,3,SolidLine));//myPen);
    kugel[i]->setBrush( QBrush( red,SolidPattern ) );     */




    if ( file.open( IO_ReadOnly ) ) {
        QTextStream stream( &file );
        QString line;
        int i = -1;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            //printf( "%3d: %s\n", i++, line.latin1() );
            i++;
            lines += line;
    kugel[i] = new MyKugel(new QCanvas());//QCanvasEllipse(myCanvas);
    kugel[i]->setX(line.toDouble());
            line = stream.readLine(); // line of text excluding '\n'
    
    kugel[i]->setY(line.toDouble());
            line = stream.readLine(); // line of text excluding '\n'

    kugel[i]->setradius(line.toDouble());
            line = stream.readLine(); // line of text excluding '\n'
    kugel[i]->setmasse(line.toDouble());

            line = stream.readLine(); // line of text excluding '\n'
    kugel[i]->setvel(line.toDouble());
   // KMessageBox::error(win,QString::number(kugel[i]->getvel()));

    
            line = stream.readLine(); // line of text excluding '\n'
    kugel[i]->setwinkel(line.toDouble());
    
            line = stream.readLine(); // line of text excluding '\n'
    kugel[i]->setsolid((line.toInt()==1) ? true : false);
   // KMessageBox::error(win,QString::number(kugel[i]->getsolid()));

             line = stream.readLine(); // line of text excluding '\n'
    kugel[i]->setladung(line.toDouble());
            line = stream.readLine(); // line of text excluding '\n'
            line = stream.readLine(); // line of text excluding '\n'
            line = stream.readLine(); // line of text excluding '\n'
            line = stream.readLine(); // line of text excluding '\n'


        QString line1 = stream.readLine(); // line of text excluding '\n'
        QString line2 = stream.readLine(); // line of text excluding '\n'
        QString line3 = stream.readLine(); // line of text excluding '\n'
    kugel[i]->setBrush(QBrush(QColor(line1.toInt(),line2.toInt(),line3.toInt()),SolidPattern));
 

    
    kugel[i]->setPen(QPen(black,3,SolidLine));//myPen);
    //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
    //kugel[i]->show();
        }
        file.close();
    }                

  
  KIO::NetAccess::removeTempFile( tmpfile );

  win->initView2();
  
  doc_url=url;
  modified=false;
  return true;
}

bool GraDoc::saveDocument(const KURL& url, const char *format /*=0*/)
{
  /////////////////////////////////////////////////
  // TODO: Add your document saving code here
  /////////////////////////////////////////////////

GraApp *win=(GraApp *) parent();

 bool ia=win->myTimer->isActive();
 win->myTimer->stop();
    //KMessageBox::error(win,url.path());
    //QStringList lines;
    QFile file( url.path() );
    if ( file.open( IO_WriteOnly ) ) {
        QTextStream stream( &file );
        //QString line;
        //int i = 1;
        for(int i=0;i<=win->kugelanz-1;i++){
            if (i!=0){stream << "\n";}

            stream << QString::number(win->kugel[i]->x()) << "\n";
            stream << QString::number(win->kugel[i]->y()) << "\n";
            stream << QString::number(win->kugel[i]->getradius()) << "\n";
            stream << QString::number(win->kugel[i]->getmasse()) << "\n";
            stream << QString::number(win->kugel[i]->getvel()) << "\n";
            stream << QString::number(win->kugel[i]->getwinkel()) << "\n";
	    stream << QString::number(win->kugel[i]->getsolid() ? 1 : 0) << "\n";
	    
	    stream << QString::number(win->kugel[i]->getladung()) << "\n";
	    stream << QString::number(0) << "\n";
	    stream << QString::number(0) << "\n";
	    stream << QString::number(0) << "\n";
	    stream << QString::number(0) << "\n";
	    
	    
            stream << QString::number((win->kugel[i]->brush()).color().red()) << "\n";
            stream << QString::number((win->kugel[i]->brush()).color().green()) << "\n";
            stream << QString::number((win->kugel[i]->brush()).color().blue());

                    
        }
        //stream << QString::number(234.34);
        file.close();
    }
  if (ia) {win->myTimer->start( 25, FALSE );}

  modified=false;
  return true;
}

void GraDoc::deleteContents()
{
  /////////////////////////////////////////////////
  // TODO: Add implementation to delete the document contents
  /////////////////////////////////////////////////

}
