
/***************************************************************************
                          graview.h  -  description
                             -------------------
    begin                : Don Nov 20 23:54:54 CET 2003
    copyright            : (C) 2003 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GRAVIEW_H
#define GRAVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>

class GraDoc;

/** The GraView class provides the view widget for the GraApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As GraView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the GraApp class to manipulate and display
 * the document structure provided by the GraDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class GraView : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    GraView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~GraView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a GraApp instance as a parent
     * widget to get to the window document pointer by calling the GraApp::getDocument() method.
     *
     * @see GraApp#getDocument
     */
    GraDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
  private:
	
};

#endif // GRAVIEW_H
