//
// C++ Implementation: qcanvasviewmouse
//
// Description: 
//
//
// Author: Walter Bender <junk@wrobix.de>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "qcanvasviewmouse.h"
#include <kmessagebox.h>
#include "kphysics.h"
#include "kphysicsdoc.h"
#include "mykugel.h"

#include <qbrush.h>

QCanvasViewMouse::QCanvasViewMouse(QWidget * parent)
 : QCanvasView(parent)
{
  myapp=parent;
  aktkugelnr=-1;
}

void QCanvasViewMouse::contentsMousePressEvent( QMouseEvent *e )
{
  GraApp *win=(GraApp*) myapp;
      
  if(win->geteditable()){  
    if(e->button()==LeftButton){
 
    
  
      int entfernung=1000;
      movekugelnr=-1;
      for(int i=0;i<win->kugelanz;i++){
        if ( (hypot (win->kugel[i]->x()-e->x() , win->kugel[i]->y()-e->y()) - win->kugel[i]->getradius()) < entfernung)
        {
          entfernung=(hypot(win->kugel[i]->x()-e->x(),win->kugel[i]->y()-e->y()) - win->kugel[i]->getradius());
          movekugelnr=i;
        }
      }
        
      
      movex=e->x();
      movey=e->y();  
    
    }
  
    if(e->button()==RightButton){
      if(aktkugelnr!=-1){
        win->kugel[aktkugelnr]->setvel(hypot(win->kugel[aktkugelnr]->x()-e->x(),win->kugel[aktkugelnr]->y()-e->y()));
        win->kugel[aktkugelnr]->setwinkel(atan2(-(win->kugel[aktkugelnr]->y()-e->y()),-(win->kugel[aktkugelnr]->x()-e->x()))/M_PI*180);
    
      }
    }
  }
   //--------------------lschen
  if(win->deleteable){
      
      //Ncste Kugel suchen, sollte man mal als eigene Funktion aufschreiben
      int entfernung=1000;
      int kugelnr=-1;
      for(int i=0;i<win->kugelanz;i++){
        if ( (hypot (win->kugel[i]->x()-e->x() , win->kugel[i]->y()-e->y()) - win->kugel[i]->getradius()) < entfernung)
        {
          entfernung=(hypot(win->kugel[i]->x()-e->x(),win->kugel[i]->y()-e->y()) - win->kugel[i]->getradius());
          kugelnr=i;
        }
      }
      if (kugelnr!=-1){
        delete win->kugel[kugelnr];
	
	MyKugel **newkugel;
	newkugel=new MyKugel *[win->kugelanz-1];
	int help=0;
	for(int i=0;i<win->kugelanz-1;i++){
	  if (i==kugelnr) help++;
	  newkugel[i]=win->kugel[i+help];
        }
	delete[] win->kugel;
	win->kugel=newkugel;
	--win->kugelanz;
	win->myCanvas->update();
      }
      
  
  }
    //--------------------Einfgen
  if(win->newable){
      
      //Ncste Kugel suchen, sollte man mal als eigene Funktion aufschreiben
        MyKugel **newkugel;
	newkugel=new MyKugel *[win->kugelanz+1];
	for(int i=0;i<(win->kugelanz);i++){
	  newkugel[i]=win->kugel[i];
        }
	newkugel[win->kugelanz]=new MyKugel(win->myCanvas);//QCanvasEllipse(myCanvas);
        newkugel[win->kugelanz]->setX(e->x());
        newkugel[win->kugelanz]->setY(e->y());
        newkugel[win->kugelanz]->setZ(0);
        newkugel[win->kugelanz]->setPen(QPen(black,3,SolidLine));//myPen);
    //kugel[i]->setBrush( QBrush( red,SolidPattern ) );
        newkugel[win->kugelanz]->setBrush(QBrush(QColor(Qt::red),SolidPattern));

        newkugel[win->kugelanz]->show();

	
	delete[] win->kugel;
	win->kugel=newkugel;
	++win->kugelanz;
	win->myCanvas->update();
      
      
  
  }
  
}
void QCanvasViewMouse::contentsMouseDoubleClickEvent ( QMouseEvent * e ){
        GraApp *win=(GraApp*) myapp;  
  
  if(win->geteditable()){  
  	
	
    if(e->button()==LeftButton){
  
    if(e->state() & Qt::ShiftButton){
      win->kugel[aktkugelnr]->setsolid(!win->kugel[aktkugelnr]->getsolid());
    }
      win->kugel[aktkugelnr]->setvel(0);
    //}
   }
  } 
}



void QCanvasViewMouse::contentsMouseReleaseEvent ( QMouseEvent * e )
{
   // if(e->x()<200){
   // KMessageBox::error(this,"Bla: "+QString::number(e->y()));}
      GraApp *win=(GraApp*) myapp;
  //win->kugel[1]->setradius(e->y());
  //win->update();
  
  // nchste Kugel bestimmen.
  
  if(win->geteditable()){  
    
    if(e->button() & LeftButton){
  
      if(movekugelnr!=-1){
        win->kugel[movekugelnr]->setX(win->kugel[movekugelnr]->x()+(e->x()-movex));
        win->kugel[movekugelnr]->setY(win->kugel[movekugelnr]->y()+(e->y()-movey)); 
        movekugelnr=-1;
      }  
  
   
  
      int entfernung=1000;
      int kugelnr=-1;
      for(int i=0;i<win->kugelanz;i++){
        if ( (hypot (win->kugel[i]->x()-e->x() , win->kugel[i]->y()-e->y()) - win->kugel[i]->getradius()) < entfernung)
        {
          entfernung=(hypot(win->kugel[i]->x()-e->x(),win->kugel[i]->y()-e->y()) - win->kugel[i]->getradius());
          kugelnr=i;
        }
      }
   
    
     
    
      QBrush mybrush;
      for(int i=0;i<win->kugelanz;i++){
     // win->kugel[i]->setradius(win->doc->kugel[i]->getradius());
        mybrush=win->kugel[i]->brush();
        mybrush.setStyle(SolidPattern);
        win->kugel[i]->setBrush(mybrush);
      }
  
  //win->kugel[kugelnr]->setradius(1);
 // mybrush->setStyle(Dense4Pattern);
    
  //win->kugel[kugelnr]->setPen(QPen(black,6,SolidLine));//myPen);
      mybrush=win->kugel[kugelnr]->brush();
      mybrush.setStyle(Dense4Pattern);
      win->kugel[kugelnr]->setBrush(mybrush);
      win->myCanvas->update();
      aktkugelnr=kugelnr;
    
    }
  
    if((e->button() & Qt::ControlButton)){
      win->kugel[aktkugelnr/*aktkugelnr*/]->setsolid(true);//!win->kugel[kugelnr]->getsolid());
      KMessageBox::error(this,"Control: ");
    }
    if((e->button() & Qt::ShiftButton)){
      win->kugel[aktkugelnr/*aktkugelnr*/]->setsolid(false);//!win->kugel[kugelnr]->getsolid());
      KMessageBox::error(this,"Shift: ");
   
    }
  }
} 

void QCanvasViewMouse::doonoff()
{
  GraApp *win=(GraApp*) myapp;
  //KMessageBox::error(this,QString::number(win->geteditable()));
   
  if(!win->geteditable()) {
    movekugelnr=-1;
    aktkugelnr=-1;
    QBrush mybrush;
    for(int i=0;i<win->kugelanz;i++){
   // win->kugel[i]->setradius(win->doc->kugel[i]->getradius());
      mybrush=win->kugel[i]->brush();
      mybrush.setStyle(SolidPattern);
      win->kugel[i]->setBrush(mybrush);
    }    
     win->myCanvas->update();
   
  }
}

void QCanvasViewMouse::setRadius(int wert)
{
  if(aktkugelnr!=-1){  
    GraApp *win=(GraApp*) myapp;
    win->kugel[aktkugelnr]->setradius(wert);
    win->myCanvas->update();
 
  } 
   
  //  KMessageBox::error(this,"jhgkhgBlahjgkjhgkjhg");
}

void QCanvasViewMouse::setLadung(int wert)
{
  if(aktkugelnr!=-1){  
    GraApp *win=(GraApp*) myapp;
    win->kugel[aktkugelnr]->setladung(wert);
    win->myCanvas->update();
 
  } 
   
  //  KMessageBox::error(this,"jhgkhgBlahjgkjhgkjhg");
}

void QCanvasViewMouse::setMasse(int wert)
{
  if(aktkugelnr!=-1){  
    GraApp *win=(GraApp*) myapp;
    win->kugel[aktkugelnr]->setmasse(wert);
    win->myCanvas->update();
 
  } 
   
  //  KMessageBox::error(this,"jhgkhgBlahjgkjhgkjhg");
}


QCanvasViewMouse::~QCanvasViewMouse()
{
}


